#ifndef __BuddhaGameWindow_H__
#define __BuddhaGameWindow_H__

#include "BuddhaXNAPrerequisites.h"
#include "BuddhaRectangle.h"

#define	BUDDHA_DEFAULT_WINDOW_WIDTH		800
#define	BUDDHA_DEFAULT_WINDOW_HEIGHT	600

namespace BuddhaXNA
{
	class Game;

	class GameWindow
	{
	private:
		/// EBhEnh
		HWND	mHandle;

		/// ^Cg
		String	mTitle;

		Rectangle mClientBounds;

		friend Game;

		GameWindow(void);

	public:
		/// EBhEnh擾
		const HWND GetHandle(void) const;

		/// ^Cgݒ
		void SetTitle(const String &title);

		/// ^Cg擾
		const String &GetTitle(void) const;

		///
		Rectangle &GetClientBounds(void);
	};
}

#endif