#ifndef __BuddhaVector2_H__
#define __BuddhaVector2_H__

#include <d3d9.h>

namespace BuddhaXNA
{
	/// QxNg\
	struct Vector2
	{
	public:
		FLOAT X;
		FLOAT Y;

		Vector2()
		{
			X = Y = 0.0f;
		}

		Vector2(FLOAT x, FLOAT y)
		{
			X = x;
			Y = y;
		}

		inline Vector2& operator = (const Vector2& value)
		{
			X = value.X;
			Y = value.Y;

			return *this;
		}

		static const Vector2 Zero;
		static const Vector2 One;
	};
}


#endif