#include "BuddhaGamepad.h"
#include "BuddhaGame.h"

using namespace BuddhaXNA;

GamePad* GamePad::m_pSingleton = NULL;

LPDIRECTINPUTDEVICE8 g_pInputDevice = NULL;

BOOL CALLBACK EnumJoyCallback(const DIDEVICEINSTANCE* pdidInstance, VOID* pContext)
{
	HRESULT hr;
	DIDEVCAPS devCaps;

	hr = Game::_getInstance()->_getDirectInput8()->CreateDevice(pdidInstance->guidInstance, &g_pInputDevice, NULL);
	if (FAILED(hr))
		return DIENUM_CONTINUE;

	devCaps.dwSize = sizeof(DIDEVCAPS);
	hr = g_pInputDevice->GetCapabilities(&devCaps);

	// ToDo

	return DIENUM_STOP;
}

namespace BuddhaXNA
{
	GamePad::GamePad()
	{
		HRESULT hr;

		LPDIRECTINPUT8 p_input = Game::_getInstance()->_getDirectInput8();

		hr = p_input->EnumDevices(DI8DEVCLASS_GAMECTRL, EnumJoyCallback, NULL, DIEDFL_ATTACHEDONLY);

		if (FAILED(hr))
			throw "dame";

		// Set getting data format.
		hr = g_pInputDevice->SetDataFormat(&c_dfDIJoystick2);
		//TODO Exception here

		hr = g_pInputDevice->SetCooperativeLevel(Game::_getInstance()->GetWindow()->GetHandle(), DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);
		//TODO Exception here


			// [hݒiΒl[hɐݒBftHgȂ̂ŕKݒ͕KvȂj
		DIPROPDWORD diprop;
		diprop.diph.dwSize	= sizeof(diprop); 
		diprop.diph.dwHeaderSize	= sizeof(diprop.diph); 
		diprop.diph.dwObj	= 0;
		diprop.diph.dwHow	= DIPH_DEVICE;
		diprop.dwData		= DIPROPAXISMODE_ABS;
	//	diprop.dwData		= DIPROPAXISMODE_REL;	// Βl[h̏ꍇ
		hr = g_pInputDevice->SetProperty(DIPROP_AXISMODE, &diprop.diph);

		//todo

		// obt@OEf[^擾邽߁Aobt@ETCYݒ
		diprop.dwData = 100; //DIDEVICE_BUFFERSIZE;
		hr = g_pInputDevice->SetProperty(DIPROP_BUFFERSIZE, &diprop.diph);

		// todo

		g_pInputDevice->Acquire();
	}
	//------------------------------------------------------------------------
	void GamePad::GetState(GamePadState &state)
	{
		HRESULT hr;

		getSingleton();	// ToDo ނႭ...

		hr = g_pInputDevice->Poll();
		if (FAILED(hr)) {
			hr = g_pInputDevice->Acquire();

			while (hr == DIERR_INPUTLOST)
				hr = g_pInputDevice->Acquire();
		}

		DIJOYSTATE2 dijs;
		hr = g_pInputDevice->GetDeviceState(sizeof(DIJOYSTATE2), (LPVOID)&dijs);
		if (SUCCEEDED(hr))
		{
			state.A = (dijs.rgbButtons[0] & 0x80) ? true : false;
			// ...
		}
	}
}

